initdb.sh 18.5 KB
Newer Older
M
 
Marc G. Fournier 已提交
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28
#!/bin/sh
#-------------------------------------------------------------------------
#
# initdb.sh--
#     Create (initialize) a Postgres database system.  
# 
#     A database system is a collection of Postgres databases all managed
#     by the same postmaster.  
#
#     To create the database system, we create the directory that contains
#     all its data, create the files that hold the global classes, create
#     a few other control files for it, and create one database:  the
#     template database.
#
#     The template database is an ordinary Postgres database.  Its data
#     never changes, though.  It exists to make it easy for Postgres to 
#     create other databases -- it just copies.
#
#     Optionally, we can skip creating the database system and just create
#     (or replace) the template database.
#
#     To create all those classes, we run the postgres (backend) program and
#     feed it data from bki files that are in the Postgres library directory.
#
# Copyright (c) 1994, Regents of the University of California
#
#
# IDENTIFICATION
29
#    $Header: /cvsroot/pgsql/src/bin/initdb/Attic/initdb.sh,v 1.97 2000/06/22 22:31:22 petere Exp $
B
Bruce Momjian 已提交
30 31 32
#
#-------------------------------------------------------------------------

33
exit_nicely(){
B
Bruce Momjian 已提交
34
    stty echo > /dev/null 2>&1
B
Bruce Momjian 已提交
35 36
    echo
    echo "$CMDNAME failed."
37
    if [ "$noclean" -eq 0 ]; then
B
Bruce Momjian 已提交
38
        echo "Removing $PGDATA."
39
        rm -rf "$PGDATA" || echo "Failed."
40 41
        echo "Removing temp file $TEMPFILE."
        rm -rf "$TEMPFILE" || echo "Failed."
B
Bruce Momjian 已提交
42 43 44 45 46 47 48 49 50
    else
        echo "Data directory $PGDATA will not be removed at user's request."
    fi
    exit 1
}


CMDNAME=`basename $0`

51 52 53 54 55
if [ "$TMPDIR" ]; then
    TEMPFILE="$TMPDIR/initdb.$$"
else
    TEMPFILE="/tmp/initdb.$$"
fi
B
Bruce Momjian 已提交
56

P
Peter Eisentraut 已提交
57 58 59 60 61 62 63 64 65 66 67 68

# Check for echo -n vs echo \c
if echo '\c' | grep -s c >/dev/null 2>&1
then
    ECHO_N="echo -n"
    ECHO_C=""
else
    ECHO_N="echo"
    ECHO_C='\c'
fi


B
Bruce Momjian 已提交
69 70 71
#
# Find out where we're located
#
72 73
if echo "$0" | grep '/' > /dev/null 2>&1 
then
B
Bruce Momjian 已提交
74 75 76 77
        # explicit dir name given
        PGPATH=`echo $0 | sed 's,/[^/]*$,,'`       # (dirname command is not portable)
else
        # look for it in PATH ('which' command is not portable)
B
Bruce Momjian 已提交
78 79
        for dir in `echo "$PATH" | sed 's/:/ /g'`
	do
B
Bruce Momjian 已提交
80 81
                # empty entry in path means current dir
                [ -z "$dir" ] && dir='.'
82
                if [ -f "$dir/$CMDNAME" ]
B
Bruce Momjian 已提交
83
		then
B
Bruce Momjian 已提交
84 85 86 87 88 89 90
                        PGPATH="$dir"
                        break
                fi
        done
fi

# Check if needed programs actually exist in path
91
for prog in postgres pg_version pg_id
B
Bruce Momjian 已提交
92
do
93
        if [ ! -x "$PGPATH/$prog" ]
B
Bruce Momjian 已提交
94
	then
B
Bruce Momjian 已提交
95 96 97 98 99 100 101 102 103 104
                echo "The program $prog needed by $CMDNAME could not be found. It was"
                echo "expected at:"
                echo "    $PGPATH/$prog"
                echo "If this is not the correct directory, please start $CMDNAME"
                echo "with a full search path. Otherwise make sure that the program"
                echo "was installed successfully."
                exit 1
        fi
done

105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120

# Gotta wait for pg_id existence check above
EffectiveUser=`$PGPATH/pg_id -n -u`
if [ -z "$EffectiveUser" ]; then
    echo "Could not determine current user name. You are really hosed."
    exit 1
fi

if [ `$PGPATH/pg_id -u` -eq 0 ]
then
    echo "You cannot run $CMDNAME as root. Please log in (using, e.g., 'su')"
    echo "as the (unprivileged) user that will own the server process."
    exit 1
fi


B
Bruce Momjian 已提交
121 122
# 0 is the default (non-)encoding
MULTIBYTEID=0
P
Peter Eisentraut 已提交
123
# This is placed here by configure --enable-multibyte[=XXX].
B
Bruce Momjian 已提交
124 125 126 127 128 129
MULTIBYTE=__MULTIBYTE__

# Set defaults:
debug=0
noclean=0
template_only=0
130
show_setting=0
B
Bruce Momjian 已提交
131 132 133 134 135

# Note: There is a single compelling reason that the name of the database
#       superuser be the same as the Unix user owning the server process:
#       The single user postgres backend will only connect as the database
#       user with the same name as the Unix user running it. That's
136
#       a security measure.
137
POSTGRES_SUPERUSERNAME="$EffectiveUser"
138
POSTGRES_SUPERUSERID=`$PGPATH/pg_id -u`
B
Bruce Momjian 已提交
139

140
while [ "$#" -gt 0 ]
B
Bruce Momjian 已提交
141 142 143 144 145 146 147 148 149 150
do
    case "$1" in
        --help|-\?)
                usage=t
                break
                ;;
        --debug|-d)
                debug=1
                echo "Running with debug mode on."
                ;;
151 152 153
        --show|-s)
        	show_setting=1
        	;;        
B
Bruce Momjian 已提交
154 155 156 157 158 159 160 161
        --noclean|-n)
                noclean=1
                echo "Running with noclean mode on. Mistakes will not be cleaned up."
                ;;
        --template|-t)
                template_only=1
                echo "Updating template1 database only."
                ;;
162
# The sysid of the database superuser. Can be freely changed.
B
Bruce Momjian 已提交
163 164 165 166 167 168 169 170 171 172
        --sysid|-i)
                POSTGRES_SUPERUSERID="$2"
                shift;;
        --sysid=*)
                POSTGRES_SUPERUSERID=`echo $1 | sed 's/^--sysid=//'`
                ;;
        -i*)
                POSTGRES_SUPERUSERID=`echo $1 | sed 's/^-i//'`
                ;;
# The default password of the database superuser.
P
Peter Eisentraut 已提交
173 174 175
# Make initdb prompt for the default password of the database superuser.
        --pwprompt|-W)
                PwPrompt=1
B
Bruce Momjian 已提交
176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200
                ;;
# Directory where to install the data. No default, unless the environment
# variable PGDATA is set.
        --pgdata|-D)
                PGDATA="$2"
                shift;;
        --pgdata=*)
                PGDATA=`echo $1 | sed 's/^--pgdata=//'`
                ;;
        -D*)
                PGDATA=`echo $1 | sed 's/^-D//'`
                ;;
# The directory where the database templates are stored (traditionally in
# $prefix/lib). This is now autodetected for the most common layouts.
        --pglib|-L)
                PGLIB="$2"
                shift;;
        --pglib=*)
                PGLIB=`echo $1 | sed 's/^--pglib=//'`
                ;;
        -L*)
                PGLIB=`echo $1 | sed 's/^-L//'`
                ;;
# The encoding of the template1 database. Defaults to what you chose
# at configure time. (see above)
201
        --encoding|-E)
B
Bruce Momjian 已提交
202 203
                MULTIBYTE="$2"
                shift;;
P
Peter Eisentraut 已提交
204 205
        --encoding=*)
                MULTIBYTE=`echo $1 | sed 's/^--encoding=//'`
B
Bruce Momjian 已提交
206
                ;;
207 208
        -E*)
                MULTIBYTE=`echo $1 | sed 's/^-E//'`
B
Bruce Momjian 已提交
209
                ;;
P
Peter Eisentraut 已提交
210 211 212 213 214
	-*)
		echo "$CMDNAME: invalid option: $1"
		echo "Try -? for help."
		exit 1
		;;
B
Bruce Momjian 已提交
215
        *)
P
Peter Eisentraut 已提交
216
                PGDATA=$1
B
Bruce Momjian 已提交
217 218 219 220 221
                ;;
    esac
    shift
done

P
Peter Eisentraut 已提交
222 223 224 225 226 227 228
if [ "$usage" ]; then
        echo "initdb initialized a PostgreSQL database."
 	echo
 	echo "Usage:"
        echo "  $CMDNAME [options] datadir"
 	echo
        echo "Options:"
P
Peter Eisentraut 已提交
229
        echo " [-D, --pgdata] <datadir>     Location for this database"
P
Peter Eisentraut 已提交
230
        echo "  -W, --pwprompt              Prompt for a password for the new superuser's"
231 232
 	if [ -n "$MULTIBYTE" ]
	then 
233
 		echo "  -E, --encoding <encoding>   Set the default multibyte encoding for new databases"
B
Bruce Momjian 已提交
234
	fi
P
Peter Eisentraut 已提交
235 236
        echo "  -i, --sysid <sysid>         Database sysid for the superuser"
        echo "Less commonly used options: "
P
Peter Eisentraut 已提交
237
        echo "  -L, --pglib <libdir>        Where to find the input files"
P
Peter Eisentraut 已提交
238 239 240
        echo "  -t, --template              Re-initialize template database only"
        echo "  -d, --debug                 Generate lots of debugging output"
        echo "  -n, --noclean               Do not clean up after errors"
241
 	echo
242
        echo "Report bugs to <pgsql-bugs@postgresql.org>."
243
 	exit 0
B
Bruce Momjian 已提交
244 245 246 247 248 249
fi

#-------------------------------------------------------------------------
# Resolve the multibyte encoding name
#-------------------------------------------------------------------------

250 251
if [ "$MULTIBYTE" ]
then
P
Peter Eisentraut 已提交
252
	MULTIBYTEID=`$PGPATH/pg_encoding $MULTIBYTE 2> /dev/null`
253
        if [ "$?" -ne 0 ]
B
Bruce Momjian 已提交
254
	then
P
Peter Eisentraut 已提交
255 256 257 258
                echo "$CMDNAME: pg_encoding failed"
                echo
                echo "Perhaps you did not configure PostgreSQL for multibyte support or"
                echo "the program was not successfully installed."
B
Bruce Momjian 已提交
259 260
                exit 1
        fi
261 262
	if [ -z "$MULTIBYTEID" ]
	then
P
Peter Eisentraut 已提交
263
		echo "$CMDNAME: $MULTIBYTE is not a valid encoding name"
B
Bruce Momjian 已提交
264 265 266 267 268 269 270 271 272
		exit 1
	fi
fi


#-------------------------------------------------------------------------
# Make sure he told us where to build the database system
#-------------------------------------------------------------------------

273 274
if [ -z "$PGDATA" ]
then
B
Bruce Momjian 已提交
275 276 277 278 279 280 281 282 283 284
    echo "$CMDNAME: You must identify where the the data for this database"
    echo "system will reside.  Do this with either a --pgdata invocation"
    echo "option or a PGDATA environment variable."
    echo
    exit 1
fi

# The data path must be absolute, because the backend doesn't like
# '.' and '..' stuff. (Should perhaps be fixed there.)

285 286
echo "$PGDATA" | grep '^/' > /dev/null 2>&1
if [ "$?" -ne 0 ]
287
then
P
Peter Eisentraut 已提交
288
    echo "$CMDNAME: data path must be specified as an absolute path"
B
Bruce Momjian 已提交
289 290 291 292 293 294 295 296
    exit 1
fi


#-------------------------------------------------------------------------
# Find the input files
#-------------------------------------------------------------------------

297 298
if [ -z "$PGLIB" ]
then
B
Bruce Momjian 已提交
299 300
        for dir in "$PGPATH/../lib" "$PGPATH/../lib/pgsql"
	do
301
                if [ -f "$dir/global1.bki.source" ]
B
Bruce Momjian 已提交
302
		then
303
                        PGLIB="$dir"
B
Bruce Momjian 已提交
304 305 306 307 308
                        break
                fi
        done
fi

309 310
if [ -z "$PGLIB" ]
then
B
Bruce Momjian 已提交
311 312 313 314 315 316 317
        echo "$CMDNAME: Could not find the \"lib\" directory, that contains"
        echo "the files needed by initdb. Please specify it with the"
        echo "--pglib option."
        exit 1
fi


318 319 320
TEMPLATE="$PGLIB"/local1_template1.bki.source
GLOBAL="$PGLIB"/global1.bki.source
PG_HBA_SAMPLE="$PGLIB"/pg_hba.conf.sample
321
POSTGRESQL_CONF_SAMPLE="$PGLIB"/postgresql.conf.sample
B
Bruce Momjian 已提交
322

323 324
TEMPLATE_DESCR="$PGLIB"/local1_template1.description
GLOBAL_DESCR="$PGLIB"/global1.description
B
Bruce Momjian 已提交
325

326
if [ "$show_setting" -eq 1 ]
327 328 329 330 331 332 333 334 335 336 337 338 339 340 341
then
	echo
	echo "The initdb setting:"
 	echo
 	echo "  DATADIR:        $PGDATA"
 	echo "  PGLIB:          $PGLIB"
 	echo "  PGPATH:         $PGPATH"
 	echo "  TEMPFILE:       $TEMPFILE"
 	echo "  MULTIBYTE:      $MULTIBYTE"
 	echo "  MULTIBYTEID:    $MULTIBYTEID"
 	echo "  SUPERUSERNAME:  $POSTGRES_SUPERUSERNAME"
 	echo "  SUPERUSERID:    $POSTGRES_SUPERUSERID"
 	echo "  TEMPLATE:       $TEMPLATE"	 
	echo "  GLOBAL:         $GLOBAL"
	echo "  PG_HBA_SAMPLE:  $PG_HBA_SAMPLE"
342
        echo "  POSTGRESQL_CONF_SAMPLE: $POSTGRESQL_CONF_SAMPLE"
343 344 345 346 347 348
	echo "  TEMPLATE_DESCR: $TEMPLATE_DESCR"
	echo "  GLOBAL_DESCR:   $GLOBAL_DESCR"
	echo 
	exit 0
fi

B
Bruce Momjian 已提交
349 350
for PREREQ_FILE in "$TEMPLATE" "$GLOBAL" "$PG_HBA_SAMPLE"
do
351 352
    if [ ! -f "$PREREQ_FILE" ]
	then 
B
Bruce Momjian 已提交
353 354 355 356 357 358 359 360 361
        echo "$CMDNAME does not find the file '$PREREQ_FILE'."
        echo "This means you have a corrupted installation or identified the"
        echo "wrong directory with the --pglib invocation option."
        exit 1
    fi
done

[ "$debug" -ne 0 ] && echo "$CMDNAME: Using $TEMPLATE as input to create the template database."

362 363
if [ "$template_only" -eq 0 ]
then
B
Bruce Momjian 已提交
364 365
    [ "$debug" -ne 0 ] && echo "$CMDNAME: Using $GLOBAL as input to create the global classes."
    [ "$debug" -ne 0 ] && echo "$CMDNAME: Using $PG_HBA_SAMPLE as default authentication control file."
B
Bruce Momjian 已提交
366
fi
B
Bruce Momjian 已提交
367

B
Bruce Momjian 已提交
368
trap 'echo "Caught signal." ; exit_nicely' 1 2 3 15
B
Bruce Momjian 已提交
369

370 371 372 373
# Let's go
echo "This database system will be initialized with username \"$POSTGRES_SUPERUSERNAME\"."
echo "This user will own all the data files and must also own the server process."
echo
B
Bruce Momjian 已提交
374

M
 
Marc G. Fournier 已提交
375 376 377 378 379 380 381
# -----------------------------------------------------------------------
# Create the data directory if necessary
# -----------------------------------------------------------------------

# umask must disallow access to group, other for files and dirs
umask 077

382 383 384
if [ -f "$PGDATA"/PG_VERSION ]
then
    if [ "$template_only" -eq 0 ]
B
Bruce Momjian 已提交
385
    then
386 387
        echo "$CMDNAME: The file $PGDATA/PG_VERSION already exists."
        echo "This probably means initdb has already been run and the"
M
 
Marc G. Fournier 已提交
388 389
        echo "database system already exists."
        echo 
390 391
        echo "If you want to create a new database system, either remove"
        echo "the directory $PGDATA or run initdb with a --pgdata argument"
M
 
Marc G. Fournier 已提交
392 393 394 395
        echo "other than $PGDATA."
        exit 1
    fi
else
396 397
    if [ ! -d "$PGDATA" ]
	then
398
        echo "Creating database system directory $PGDATA"
399
        mkdir "$PGDATA" || exit_nicely
400 401
    else
        echo "Fixing permissions on pre-existing data directory $PGDATA"
402
	chmod go-rwx "$PGDATA" || exit_nicely
M
 
Marc G. Fournier 已提交
403
    fi
404

405 406
    if [ ! -d "$PGDATA"/base ]
	then
407
        echo "Creating database system directory $PGDATA/base"
408
        mkdir "$PGDATA"/base || exit_nicely
M
 
Marc G. Fournier 已提交
409
    fi
410
    if [ ! -d "$PGDATA"/pg_xlog ]
B
Bruce Momjian 已提交
411
    then
412
        echo "Creating database XLOG directory $PGDATA/pg_xlog"
413
        mkdir "$PGDATA"/pg_xlog || exit_nicely
414
    fi
M
 
Marc G. Fournier 已提交
415 416 417 418 419 420
fi

#----------------------------------------------------------------------------
# Create the template1 database
#----------------------------------------------------------------------------

421 422
rm -rf "$PGDATA"/base/template1 || exit_nicely
mkdir "$PGDATA"/base/template1 || exit_nicely
M
 
Marc G. Fournier 已提交
423

424 425
if [ "$debug" -eq 1 ]
then
M
 
Marc G. Fournier 已提交
426 427 428 429 430 431
    BACKEND_TALK_ARG="-d"
else
    BACKEND_TALK_ARG="-Q"
fi

BACKENDARGS="-boot -C -F -D$PGDATA $BACKEND_TALK_ARG"
432
FIRSTRUN="-boot -x -C -F -D$PGDATA $BACKEND_TALK_ARG"
M
 
Marc G. Fournier 已提交
433

B
Bruce Momjian 已提交
434
echo "Creating template database in $PGDATA/base/template1"
435
[ "$debug" -ne 0 ] && echo "Running: $PGPATH/postgres $FIRSTRUN template1"
M
 
Marc G. Fournier 已提交
436

437
cat "$TEMPLATE" \
438
| sed -e "s/PGUID/$POSTGRES_SUPERUSERID/g" \
439
| "$PGPATH"/postgres $FIRSTRUN template1 \
440
|| exit_nicely
M
 
Marc G. Fournier 已提交
441

442
"$PGPATH"/pg_version "$PGDATA"/base/template1 || exit_nicely
M
 
Marc G. Fournier 已提交
443 444 445 446 447

#----------------------------------------------------------------------------
# Create the global classes, if requested.
#----------------------------------------------------------------------------

448 449
if [ "$template_only" -eq 0 ]
then
450 451
    echo "Creating global relations in $PGDATA/base"
    [ "$debug" -ne 0 ] && echo "Running: $PGPATH/postgres $BACKENDARGS template1"
M
 
Marc G. Fournier 已提交
452

453
    cat "$GLOBAL" \
454 455
    | sed -e "s/POSTGRES/$POSTGRES_SUPERUSERNAME/g" \
          -e "s/PGUID/$POSTGRES_SUPERUSERID/g" \
456
    | "$PGPATH"/postgres $BACKENDARGS template1 \
457
    || exit_nicely
M
 
Marc G. Fournier 已提交
458

459
    "$PGPATH"/pg_version "$PGDATA" || exit_nicely
M
 
Marc G. Fournier 已提交
460

461
    cp "$PG_HBA_SAMPLE" "$PGDATA"/pg_hba.conf     || exit_nicely
462
    cp "$POSTGRESQL_CONF_SAMPLE" "$PGDATA"/postgresql.conf || exit_nicely
463
    chmod 0600 "$PGDATA"/pg_hba.conf "$PGDATA"/postgresql.conf
M
 
Marc G. Fournier 已提交
464

465
    echo "Adding template1 database to pg_database"
M
 
Marc G. Fournier 已提交
466

467
    echo "open pg_database" > "$TEMPFILE"
468
    echo "insert (template1 $POSTGRES_SUPERUSERID $MULTIBYTEID template1)" >> $TEMPFILE
469 470
    #echo "show" >> "$TEMPFILE"
    echo "close pg_database" >> "$TEMPFILE"
M
 
Marc G. Fournier 已提交
471

472
    [ "$debug" -ne 0 ] && echo "Running: $PGPATH/postgres $BACKENDARGS template1 < $TEMPFILE"
M
 
Marc G. Fournier 已提交
473

474
    "$PGPATH"/postgres $BACKENDARGS template1 < "$TEMPFILE"
475
    # Gotta remove that temp file before exiting on error.
476
    retval="$?"
477
    rm -f "$TEMPFILE" || exit_nicely
478
    [ "$retval" -ne 0 ] && exit_nicely
M
 
Marc G. Fournier 已提交
479 480 481 482
fi

echo

483
PGSQL_OPT="-o /dev/null -O -F -D$PGDATA"
M
 
Marc G. Fournier 已提交
484

B
Bruce Momjian 已提交
485 486
# Create a trigger so that direct updates to pg_shadow will be written
# to the flat password file pg_pwd
487 488
echo "CREATE TRIGGER pg_sync_pg_pwd AFTER INSERT OR UPDATE OR DELETE ON pg_shadow" \
     "FOR EACH ROW EXECUTE PROCEDURE update_pg_pwd()" \
489
     | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
B
Bruce Momjian 已提交
490

P
Peter Eisentraut 已提交
491 492
# needs to be done before alter user
echo "REVOKE ALL on pg_shadow FROM public" \
493
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
494

P
Peter Eisentraut 已提交
495 496 497
# set up password
if [ "$PwPrompt" ]; then
    $ECHO_N "Enter new superuser password: "$ECHO_C
B
Bruce Momjian 已提交
498
    stty -echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
499
    read FirstPw
B
Bruce Momjian 已提交
500
    stty echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
501 502
    echo
    $ECHO_N "Enter it again: "$ECHO_C
B
Bruce Momjian 已提交
503
    stty -echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
504
    read SecondPw
B
Bruce Momjian 已提交
505
    stty echo > /dev/null 2>&1
P
Peter Eisentraut 已提交
506 507 508 509 510 511 512 513 514 515 516 517 518 519
    echo
    if [ "$FirstPw" != "$SecondPw" ]; then
        echo "Passwords didn't match."
        exit_nicely
    fi
    echo "ALTER USER \"$POSTGRES_SUPERUSERNAME\" WITH PASSWORD '$FirstPw'" \
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
    if [ ! -f $PGDATA/pg_pwd ]; then
        echo "The password file wasn't generated. Please report this problem."
        exit_nicely
    fi
    echo "Setting password"
fi

520 521

echo "Creating view pg_user."
522 523 524 525 526 527 528 529 530 531
echo "CREATE VIEW pg_user AS \
        SELECT \
            usename, \
            usesysid, \
            usecreatedb, \
            usetrace, \
            usesuper, \
            usecatupd, \
            '********'::text as passwd, \
            valuntil \
532
        FROM pg_shadow" \
533
        | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
534 535

echo "Creating view pg_rules."
536 537 538 539 540 541 542
echo "CREATE VIEW pg_rules AS \
        SELECT \
            C.relname AS tablename, \
            R.rulename AS rulename, \
	    pg_get_ruledef(R.rulename) AS definition \
	FROM pg_rewrite R, pg_class C \
	WHERE R.rulename !~ '^_RET' \
543
            AND C.oid = R.ev_class;" \
544
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
545 546

echo "Creating view pg_views."
547 548 549 550 551 552 553 554 555 556
echo "CREATE VIEW pg_views AS \
        SELECT \
            C.relname AS viewname, \
            pg_get_userbyid(C.relowner) AS viewowner, \
            pg_get_viewdef(C.relname) AS definition \
        FROM pg_class C \
        WHERE C.relhasrules \
            AND	EXISTS ( \
                SELECT rulename FROM pg_rewrite R \
                    WHERE ev_class = C.oid AND ev_type = '1' \
557
            )" \
558
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
559 560

echo "Creating view pg_tables."
561 562 563 564 565 566 567 568 569 570 571 572
echo "CREATE VIEW pg_tables AS \
        SELECT \
            C.relname AS tablename, \
	    pg_get_userbyid(C.relowner) AS tableowner, \
	    C.relhasindex AS hasindexes, \
	    C.relhasrules AS hasrules, \
	    (C.reltriggers > 0) AS hastriggers \
        FROM pg_class C \
        WHERE C.relkind IN ('r', 's') \
            AND NOT EXISTS ( \
                SELECT rulename FROM pg_rewrite \
                    WHERE ev_class = C.oid AND ev_type = '1' \
573
            )" \
574
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
575 576

echo "Creating view pg_indexes."
577 578 579 580 581 582 583
echo "CREATE VIEW pg_indexes AS \
        SELECT \
            C.relname AS tablename, \
	    I.relname AS indexname, \
            pg_get_indexdef(X.indexrelid) AS indexdef \
        FROM pg_index X, pg_class C, pg_class I \
	WHERE C.oid = X.indrelid \
584
            AND I.oid = X.indexrelid" \
585
        | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
586 587

echo "Loading pg_description."
588 589 590 591 592
echo "COPY pg_description FROM STDIN" > $TEMPFILE
cat "$TEMPLATE_DESCR" >> $TEMPFILE
cat "$GLOBAL_DESCR" >> $TEMPFILE

cat $TEMPFILE \
593
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
594
rm -f "$TEMPFILE" || exit_nicely
595

596 597
echo "Vacuuming database."
echo "VACUUM ANALYZE" \
598
	| "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
599 600

echo
601
echo "Success. You can now start the database server using:"
602 603 604 605
echo ""
echo "	$PGPATH/postmaster -D $PGDATA"
echo "or"
echo "	$PGPATH/pg_ctl -D $PGDATA start"
606 607 608
echo

exit 0